\chapter{Introduction}
\label{Introduction}
\thispagestyle{empty}

% \begin{quotation}
% {\footnotesize
% \noindent{\emph{``Terence: Rotta a nord con circospezione \\
% Bud: Ehi, gli ordini li do io qui!\\
% Terence: Ok, comante\\
% Bud: Rotta a nord\\
% Terence: Soltanto?\\
% Bud: Con circospezione!''}
% }
% \begin{flushright}
% Chi Trova un Amico Trova un Tesoro
% \end{flushright}
% }
% \end{quotation}
% \vspace{0.5cm}


% Provi a rispondere alle domande: perché dobbiamo esplorare/visitare corpi celesti? Perché dobbiamo atterrare sui corpi celesti? Quali sono le sfide principali e cosa eventualmente manca? Come si inquadra la tesi in questo scenario? Etc.

\noindent Being the nearest celestial body to the Earth, it is natural that the Moon has always been of interest for space science and exploration. The exploration of the Moon started during the Cold War between the Soviet Union and the United States of America \cite{moon_exploration}. After World War II, it began what is called the Space Race, that is a kind of technological competition between the two main world powers on who would achieve first in spaceflight capabilities. The first lunar mission was in 1959, just two years after the launch of the Sputnik, with the Soviet probe Luna 1, which was followed in the later years by a large number of other Soviet and American missions. In 1966 the first lander Luna 9, by Soviet Union, reached the lunar surface. The Soviet Union achieved a few other primacies, but it was the United States that, thanks to the rocket technology brought by the legendary German aerospace engineer Wernher Von Braun, achieved the primacy of bringing the man to the Moon in 1969 with the Apollo 11 mission \cite{apollo11}, during the Apollo Program. Apollo 11 was followed by other successful Apollo missions (except Apollo 13), some of which installed on the lunar surface scientific instruments and brought back to the Earth samples of lunar rocks. From the mid-1960s to the mid-1970s there were 65 Moon landings, but after Luna 24 in 1976 they suddenly stopped: the Soviet Union started focusing on Venus and space stations and the U.S. on Mars and beyond, and on the Skylab and Space Shuttle programs.

In more recent years, new countries decided to send their own probes to carry out scientific exploration of the Moon. In particular Japan, with the Hiten spacecraft in 1990 and with the SELENE spacecraft in 2007, with the goal "to obtain scientific data of the lunar origin and evolution and to develop the technology for the future lunar exploration", according the the JAXA official website \cite{SELENE}. Also ISRO, India's space agency, sent a spacecraft on the Moon, discovering the presence of water molecules. China recently sent a rover on the dark side of the Moon, to explore a zone that we know very little about. The Moon is of scientific interest in order to better understand the origins of the solar system and to study the distribution of water in it. There is still a lot to explore on the Moon, because the Apollo missions only covered a little part of the surface, in particular on the equatorial zone. 

While SpaceX is working to colonize Mars in order to make Humanity a multiplanetary specie \cite{spacex_mars}, other space agencies like the European Space Agency (ESA) have targeted the Moon as a possible outpost to build a base \cite{esa_moon_base}. In order to achieve this, it is required a robust technology to perform planetary landing. The number of landing failures also in recent years proves that the technology is still not mature enough. During the landing of Apollo 11, the lander risked of finishing the fuel, and it was mainly thank to the exceptional piloting skills of Neil Armstrong that it managed to perform a soft landing in a safe zone. Mars was denominated the \textit{Great Galactic Ghoul} because of the great number of probes lost trying to reach its surface \cite{galactic_ghoul}. The problem of Mars is that it is so far that also the telecommunications suffer a delay big enough to jeopardize the mission. The failures on Mars were not only restricted to human errors, but also software failures (the most recent was the Schiaparelli lander). These are all reasons why it is desirable to be able to rely on a robust software than can perform autonomous and optimal landing. The optimal landing problem requires to solve a two-points-boundary-value-problem (TPBVP), which is computationally intense and thus cannot be performed on-board in real-time. The goal of this thesis is contributing in the study of Machine Learning techniques to perform an optimal landing in real-time. 


\section{State of the art}
Supervised imitation learning has been applied to optimal lunar landing in a few research studies. In one of these works, Sanchez and Izzo \cite{izzo1} implemented a deep neural network (DNN), assuming perfect knowledge of position and velocity, for 2D a fuel optimal (FO) landing problem. They demonstrated how DNNs can be trained to learn the optimal state-feedback in a number of continuous time, deterministic, non-linear systems of interest in the aerospace domain. They suggested that the networks trained did learn the solution to Hamilton-Jacobi-Bellman (HJB) equations underlying the optimal control problem, because they were able to generalize on points well outside the train set. They also analyzed and tried different network architectures, varying the number of hidden layers and neurons per layer, and different activation functions, demonstrating that shallow networks are not sufficient to represent satisfactorily the complexity of the problem.

In another study, Bloise and Orlandelli \cite{bloise_orlandelli} implemented a recurrent neural network (RNN) for the fuel optimal landing problem. They generated the optimal trajectories for the train set with the General Pseudospectral Optimal Control Software (GPOPS), both in 1D and 2D cases. They trained the network on two main problems: first, assuming perfect knowledge of position and velocity and mapping them to the thrust; then, generating images of the Moon surface and mapping them to the thrust, thus avoiding the need of knowing position and velocity. A RNN combined to a CNN is used for the second problem, because having a series of image is needed in order to have information about the lander velocity. The CNN processes the images, while the RNN extracts information from the images sequence.

None of these studies considered the fact that sequential prediction problems such as imitation learning, where future observations depend on previous predictions (actions), violate the \textit{independent-and-identically-distributed} (i.i.d.) assumption commonly made in statistical learning. In the following section it is explained what this means and what consequences it implies.



\section{Work justification and purposes}
\label{sec:work_justification_and_purposes}
As Ross et al. stated in \cite{dagger}: \textit{"Sequential prediction problems such as imitation learning, where future observations depend on previous predictions (actions), violate the common i.i.d. assumptions made in statistical learning. This leads to poor performance in theory and often in practice. In particular, a classifier that makes a mistake with probability $\epsilon$ under the distribution of states/observations encountered by the expert, can make as many as $T^2 \epsilon$ mistakes in expectation over T-steps under the distribution of states the classifier itself induces."}. Put in other words, it means that the agent can be trained with optimal trajectories, but when it comes to the simulation, every prediction error will cause the agent to find itself in a state which is likely not present in the training set (unless the train set covers the entire space of possible states). This increases the probability of committing another prediction error, thus making the trajectory diverge from the target. The solution to this problem proposed in \cite{dagger} is the DAgger algorithm (which will be explained in detail in section \ref{sec:dagger}), an iterative procedure to train a deterministic policy that achieves good performances guarantees under its induces distribution of states. In that paper, DAgger is applied to simple classification problems in video games. The aim of this work is to prove that the DAgger algorithm can be applied to the optimal landing problem successfully and effectively improving the performances of the ML model during the Monte Carlo simulation. It will be shown that the DAgger algorithm allows achieving good performances with relatively small datasets, and to outperform classical supervised learning with parity of training set size.


\section{Proposed approach}
\label{sec:proposed_approach}
The approach proposed to carry out the purposes explained in the previous section is demonstrating the effectiveness of the DAgger algorithm to problems with gradually increasing difficulty. The energy optimal (EO) problem is first tackled: the nature of the EO problem is much simpler than FO problem, and the thrust provided by the engine is not constrained in order to simplify even further. Then, once the DAgger procedure has been tested and proved to work, the FO problem is studied. For both problems, it is first studied the 1D case and then the 3D case. Considerations on the train set size, type of network, model architecture and input feature are made for each case, as well as the criteria to apply DAgger.

The software used to generate optimal trajectories are respectively ZEM/ZEV for the EO problem and GPOPS for the FO problem. They are both implemented in Matlab. The Machine Learning framework used is Keras/Tensorflow, and the code used to train the models, to perform the Monte Carlo simulations and to carry out all the data analysis is in Python.



\section{Thesis structure}
Chapter \ref{chapter2} covers the basics of Machine Learning theory, starting from the definition of supervised and imitation learning, to the explanation of DAgger and finally the theory behind the two ML models used in this work, that is DNN and ELM. The performance indexes used to quantify the quality of the training for each kind of problem are explained. Chapter \ref{chapter3} is on the EO landing problem. It begins formalizing the EO problem and giving some useful information about the software used to generate the train and test trajectory for this problem. Then, it shows how the train set is generated, the procedure to apply DAgger to the EO problem, the tools to visualize the improvements brought by the applization of DAgger, and the performances of DNN and ELM, both in 1D and 3D cases. Chapter \ref{chapter4} follows the same structure of the previous chapter, but this time on FO problem. Chapter \ref{chapter5} is about conclusions and future work.